InsuranceClaim/Controllers/VehicleMakeController.cs
using AutoMapper;
using Insurance.Domain;
using InsuranceClaim.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace InsuranceClaim.Controllers
{
    public class VehicleMakeController : Controller
    {
        // GET: VehicleMake
        public ActionResult Index()
        {


            InsuranceClaim.Models.VehiclesMakeModel obj = new InsuranceClaim.Models.VehiclesMakeModel();
            List<Insurance.Domain.VehicleMake> objList = new List<Insurance.Domain.VehicleMake>();
            objList = InsuranceContext.VehicleMakes.All().ToList();

            return View(obj);
        }

        // GET: VehicleMake/Details/5
        [HttpPost]
        public ActionResult SaveVehicleMake(VehiclesMakeModel Model)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    var dbVehicalMake = InsuranceContext.VehicleMakes.Single(where: $"MakeDescription = '" + Model.MakeDescription + "'");

                    if (dbVehicalMake == null)
                    {
                        var dbModel = Mapper.Map<VehiclesMakeModel, VehicleMake>(Model);
                        dbModel.CreatedOn = DateTime.Now;
                        dbModel.ModifiedOn = DateTime.Now;
                        dbModel.MakeDescription = Model.MakeDescription.ToUpper();
                        dbModel.MakeCode = Model.MakeCode;
                        dbModel.ShortDescription = Model.ShortDescription;

                        InsuranceContext.VehicleMakes.Insert(dbModel);
                    }

                }
                else
                {
                    return RedirectToAction("VehicleMakeList");
                }

            }
            catch (Exception ex)
            {
                TempData["ErroMsg"] = ex.Message;
                //  View(Model);
            }

            return RedirectToAction("VehicleMakeList");
        }

        // GET: VehicleMake/Create
        public ActionResult VehicleMakeList()
        {

          

            var makelist = InsuranceContext.VehicleMakes.All(where: "IsActive = 'True' or IsActive is Null").OrderByDescending(x => x.Id).ToList();
            return View(makelist);
        }

        public ActionResult VehicleMakeEdit(int Id)
        {
            var record = InsuranceContext.VehicleMakes.All(where: $"Id ={Id}").FirstOrDefault();

            var model = Mapper.Map<VehicleMake, VehiclesMakeModel>(record);
            return View(model);
        }
        [HttpPost]
        public ActionResult VehicleMakeEdit(VehiclesMakeModel model)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    var makeid = model.Id;
                    //var data = Mapper.Map<VehiclesMakeModel, VehicleMake>(model);
                    var data = InsuranceContext.VehicleMakes.Single(where: $"Id = {makeid}");

                    if(data!=null)
                    {
                        if(!CheckMakeExist(data.MakeDescription, model.MakeDescription))
                        {
                            TempData["errorMsg"] = "Make description already exist, please try again.";
                            return View(model);
                        }
                    }

                    data.MakeDescription = model.MakeDescription.ToUpper();
                    data.MakeCode = model.MakeCode;
                    data.ShortDescription = model.ShortDescription;
                    //data.CreatedOn = model.CreatedOn;
                    data.ModifiedOn = DateTime.Now;
                    InsuranceContext.VehicleMakes.Update(data);

                }

            }
            catch (Exception ex)
            {

            }
            return RedirectToAction("VehicleMakeList");
        }

        private bool CheckMakeExist(string oldMake, string newMake)
        {

            if(oldMake== newMake)
            {
                return true;
            }
            else
            {

                var dbVehicalMake = InsuranceContext.VehicleMakes.Single(where: $"MakeDescription = '" + newMake + "'");

                if(dbVehicalMake!=null)
                {
                    return false;
                }


            }

            return true;
        }

        public ActionResult DeleteMake(int id)
        {
            var makeDetials = InsuranceContext.VehicleMakes.Single(id);

            if(makeDetials!=null)
            {
                var vehicelDetials = InsuranceContext.VehicleDetails.Single(where: $"MakeId='{makeDetials.MakeCode}'");

                if(vehicelDetials==null)
                {
                    string query = $"update VehicleMake set IsActive =0 where Id={id}";
                    InsuranceContext.VehicleMakes.Execute(query);
                }
                else
                {
                    TempData["errorMsg"] = "Vehicle exist for this Make.";
                }

            }

            

            return RedirectToAction("VehicleMakeList");
        }




    }
}

InsuranceClaim/Views/VehicleMake/Index.cshtml
@model InsuranceClaim.Models.VehiclesMakeModel
@{
    ViewBag.Title = "VehicleMakeDetail";
    Layout = "~/Views/Shared/_InsuranceMain.cshtml";
}


<div class="body-content-section">
    <div class="form-section-top">
        <div class="container">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 form-section-col">
                    <div class="form-group-section">
                        <div class="form-title">
                            <h4>Add Vehicle Make</h4>
                        </div>

                        <div class="form-group-input">
                            @*@using (Ajax.BeginForm("SaveCustomerData", "CustomerRegistration", new AjaxOptions { UpdateTargetId = "CustomerResult", OnSuccess = "GoToProductDetail" }))*@
                            @using (Html.BeginForm("SaveVehicleMake", "VehicleMake", FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
                            {
                                @Html.HiddenFor(x => x.Id)

                                <div class="row">
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.MakeDescription, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.MakeDescription, new { @class = "form-control", @name = "MakeDescription", @autocomplete = "off", @id = "MakeDescription", @placeholder = "Enter Make Description" })
                                            @Html.ValidationMessageFor(x => x.MakeDescription, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.MakeCode, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.MakeCode, new { @class = "form-control", @name = "MakeCode", @autocomplete = "off", @id = "MakeCode", @placeholder = "Enter Make Code" })
                                            @Html.ValidationMessageFor(x => x.MakeCode, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.ShortDescription, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.ShortDescription, new { @class = "form-control", @name = "ShortDescription", @autocomplete = "off", @id = "ShortDescription", @placeholder = "Enter Short Description" })
                                            @Html.ValidationMessageFor(x => x.ShortDescription, "", new { @class = "text-danger" })
                                        </div>
                                    </div>

                                </div>
                                

                                @*<input type="submit"  class="btn btn-primary"name="Save"/>*@
                                <div class="col-md-12 next-btn">
                                    <div class="row">
                                        <div class="col-sm-6 col-md-6">
                                            <div class="text-left">
                                                <button type="button" class="btn" onclick="window.location.href='@Url.Action("VehicleMakeList","VehicleMake")'">Cancel</button>

                                            </div>
                                        </div>
                                        <div class="col-sm-6 col-md-6">
                                            <div class="text-right">
                                                <button type="submit" class="btn">Add</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>




</div>

InsuranceClaim/Views/VehicleMake/VehicleMakeEdit.cshtml
@model InsuranceClaim.Models.VehiclesMakeModel
@{
    ViewBag.Title = "VehicleMakeEdit";
    Layout = "~/Views/Shared/_InsuranceMain.cshtml";
}




<div class="body-content-section">
    <div class="form-section-top">
        <div class="container">
            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 form-section-col">
                    <div class="form-group-section">
                        <div class="form-title">
                            <h2>Vehicle Make Edit</h2>
                        </div>

                        


                        <div class="form-group-input">
                            @*@using (Ajax.BeginForm("SaveCustomerData", "CustomerRegistration", new AjaxOptions { UpdateTargetId = "CustomerResult", OnSuccess = "GoToProductDetail" }))*@
                            @using (Html.BeginForm("VehicleMakeEdit", "VehicleMake", FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
                            {
                                @Html.HiddenFor(x => x.Id)

                                if (TempData["errorMsg"] != null)
                                {
                                    <div class="alert alert-danger ">
                                        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                        <strong>@TempData["errorMsg"]</strong> .
                                    </div>
                                }



                                <div class="row">
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.MakeDescription, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.MakeDescription, new { @class = "form-control", @name = "MakeDescription", @autocomplete = "off", @id = "MakeDescription", @placeholder = "Enter Make Description" })
                                            @Html.ValidationMessageFor(x => x.MakeDescription, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.MakeCode, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.MakeCode, new { @class = "form-control", @name = "MakeCode", @autocomplete = "off", @id = "MakeCode", @placeholder = "Enter Make Code" })
                                            @Html.ValidationMessageFor(x => x.MakeCode, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-sm-6 col-md-6 form-group-text">
                                        <div class="form-group">
                                            @Html.LabelFor(x => x.ShortDescription, new { @class = "gender-label" })
                                            @Html.TextBoxFor(x => x.ShortDescription, new { @class = "form-control", @name = "ShortDescription", @autocomplete = "off", @id = "ShortDescription", @placeholder = "Enter Short Description" })
                                            @Html.ValidationMessageFor(x => x.ShortDescription, "", new { @class = "text-danger" })
                                        </div>
                                    </div>
                                    @*<div class="col-sm-6 col-md-6 form-group-text">
                                            <div class="form-group">
                                                @Html.LabelFor(x => x.MinCompAmount, new { @class = "gender-label" })
                                                @Html.TextBoxFor(x => x.MinCompAmount, new { @class = "form-control", @name = "MinCompAmount", @autocomplete = "off", @id = "MinCompAmount", @placeholder = "Enter Min Comp Amount" })
                                                @Html.ValidationMessageFor(x => x.MinCompAmount, "", new { @class = "text-danger" })
                                            </div>
                                        </div>*@
                                </div>


                                @*<input type="submit"  class="btn btn-primary"name="Save"/>*@
                                <div class="col-md-12 next-btn">
                                    <div class="row">
                                        <div class="col-sm-6 col-md-6">
                                            <div class="text-left">
                                                <button type="button" class="btn" onclick="window.location.href='@Url.Action("VehicleMakeList","VehicleMake")'">Cancel</button>

                                            </div>
                                        </div>
                                        <div class="col-sm-6 col-md-6">
                                            <div class="text-right">
                                                <button type="submit" class="btn">Update</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>




</div>

InsuranceClaim/Views/VehicleMake/VehicleMakeList.cshtml
@model  List<Insurance.Domain.VehicleMake>
@{
    ViewBag.Title = "VehicleMakeList";
    Layout = "~/Views/Shared/_InsuranceMain.cshtml";
}



@using (Html.BeginForm("VehicleMakeList", "VehicleMake", FormMethod.Post, new { @class = "form-horizontal", role = "form" }))
{
    <div class="productsave-section">
        <div class="container">
            <div class="row">
                <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 products-top">
                    <div class="head-title">
                        <h2>Vehicle Make List</h2>
                    </div>
                </div>

                <div class="col-xs-6 col-sm-6 col-md-6 col-lg-6 products-top">
                    <div class="text-left">
                        @Html.TextBox("searchText", null, new { @class = "form-control", @placeholder = "Name" })
                    </div>
                </div>

            </div>

            <div class="row">
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 add-btn">
                    <div class="">
                        <form>
                            <input class="btn btn-primary" type="button" value="Add" onclick="window.location.href='@Url.Action("Index", "VehicleMake")'" />
                        </form>
                    </div>
                </div>

               

            </div>

            <div class="row">
                <br />
                @if (TempData["errorMsg"] != null)
                {
                    <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12 form-section-col alert alert-danger">
                        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                        <strong>@TempData["errorMsg"]</strong> .
                    </div>
                }

            </div>




            <div class="product-table-grid">
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th>Make Description</th>
                            <th>Make Code</th>
                            <th>Short Description</th>
                            <th class="action-th">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach (Insurance.Domain.VehicleMake item in Model)
                        {
                            <tr>
                                <td>@item.MakeDescription</td>
                                <td>@item.MakeCode</td>
                                <td>@item.ShortDescription</td>
                                <td>
                                    <div class="tbl-btn-list">
                                        <ul class="list-inline">
                                            <li>@Html.ActionLink("Edit", "VehicleMakeEdit", new { id = item.Id }, new { @class = "btn-sm btn-primary" })</li>
                                            <li><button type="button" class="btn-sm btn-danger" onclick="ShowPopupp('@item.Id')">Delete</button></li>
                                        </ul>
                                    </div>


                                </td>
                            </tr>
                        }
                    </tbody>
                </table>
            </div>

        </div>
        <div class="modal fade" id="MyModal" role="dialog">
            <div class="modal-dialog">
                <!-- Modal content-->
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <p style="text-align: center;color: #00bcea;font-weight: bold;">Are you sure you want to delete this?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" onclick="ConfirmDelete();">Yes</button>
                        <button type="button" class="btn btn-default" data-dismiss="modal">No</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
}





<script>
    let MakeId;
    function ShowPopupp(Id) {
        debugger;
        $("#MyModal").modal("show");
        MakeId = Id;
    }
    function ConfirmDelete() {
        debugger;

        var url = "@Url.Action("DeleteMake", "VehicleMake", new { Id=123 })";
        var newurl = url.replace("123", MakeId);
        window.location.href = newurl;
    }


    $(document).ready(function () {
        $("#searchText").on("keyup", function () {
            var value = $(this).val().toLowerCase();
            $(".table>tbody tr").filter(function () {
                $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
            });
        });
    });



</script>